diff --git a/pc-bios/README b/pc-bios/README
index 5a8a931..779192e 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -17,7 +17,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20160223.
+  built from git tag qemu-slof-20161019.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index f2384939efd167dad1153ac744d0624ad8591cfa..30ce7ac384146c1a30c2b3067ccd532efe78f189 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index e3d0572..efd65f4 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit e3d05727a074619fc12d0a67f05cf2c42c875cce
+Subproject commit efd65f49929d7db775b26066d538c8120ae3db94