diff --git a/pc-bios/README b/pc-bios/README
index 47a913f..dcead36 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -17,7 +17,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20161019.
+  built from git tag qemu-slof-20170303.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index 30ce7ac384146c1a30c2b3067ccd532efe78f189..0408723dbf693e3385e4f023e5e2cfe5f715b5f5 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index efd65f4..66d250e 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit efd65f49929d7db775b26066d538c8120ae3db94
+Subproject commit 66d250ef0fd06bb88b7399b9563b5008201f2d63