diff --git a/pc-bios/README b/pc-bios/README
index 99e15a737b..90f0fa7aa7 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -17,7 +17,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20180621.
+  built from git tag qemu-slof-20180702.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index 4e0e33f8297888ca8e143be784c30ce404f072cd..6274a6739187a9cd12a50b1bda2313c9f0d481a5 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index 7d37babcfa..9b7ab2fa02 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit 7d37babcfa48a6eb08e726a8d13b745cb2eebe1c
+Subproject commit 9b7ab2fa020341dee8bf9df6c9cf40003e0136df