diff --git a/pc-bios/README b/pc-bios/README
index a5a770f066..fa8b58b797 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -14,7 +14,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20200327.
+  built from git tag qemu-slof-20200717.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index 80bbf91a186c7eec76af3ae6af50c2c841a77579..448dcada367f32130ff6ccc6dcb482dcc3fa853e 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index 8e012d6fdd..e18ddad851 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit 8e012d6fddb62be833d746cef3f03e6c8beecde0
+Subproject commit e18ddad8516ff2cfe36ec130200318f7251aa78c